package com.customization.jucailinkq.workflow;

import com.engine.core.cfg.annotation.CommandDynamicProxy;
import com.engine.core.interceptor.AbstractCommandProxy;
import com.engine.core.interceptor.Command;
import com.engine.workflow.cmd.monitor.DoRepossessedCmd;
import lombok.extern.slf4j.Slf4j;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.workflow.workflow.RequestForceDrawBack;

import java.util.Map;


/**
 * 流程强制收回代理类
 */
@Slf4j
@CommandDynamicProxy(target = DoRepossessedCmd.class, desc="流程强制收回")
public class KQDoRepossessedProxyCmd extends AbstractCommandProxy<Map<String,Object>> {
    @Override
    public Map<String, Object> execute(Command<Map<String, Object>> command) {

        BaseBean bb = new BaseBean();
        bb.writeLog("DoRepossessedProxyCmd start");
        log.info("DoRepossessedProxyCmd start");
        Map<String, Object> resultMap = nextExecute(command);

        RecordSet rs = new RecordSet();
        Map<String, Object> requestMap = (Map<String, Object>)resultMap.get("result");
        bb.writeLog("DoRepossessedProxyCmd requestMap"+requestMap.toString());
        requestMap.entrySet().forEach(e->{
            String requestId = e.getKey();
            String status = e.getValue().toString();
            if (status.equals(RequestForceDrawBack.SUCCESS)){
                rs.executeProc("workflow_Requestbase_SByID", requestId);
                int workflowid = rs.getInt("workflowid");
                bb.writeLog("DoRepossessedProxyCmd workflowid"+workflowid);
            }
        });

        return resultMap;
    }
}
